Subject: Re: [bug#37305] [PATCH v3] Allow booting from a Btrfs subvolume

From: Ludovic Courtès <[email-masked]>
Date: Thu, 21 May 2020 00:03:47 +0200

Hi Maxim,

Maxim Cournoyer <[email-masked]> skribis:

[...]

>>>  (define* (grub-configuration-file config entries
>>>                                    #:key
>>>                                    (system (%current-system))
>>> -                                  (old-entries '()))
>>> +                                  (old-entries '())
>>> +                                  btrfs-subvolume-file-name)
>>
>> I wonder if we should just call it ‘store-directory-prefix’ or similar
>> since, after all, it’s just about prepending a prefix, which could
>> perhaps be useful for file systems other than Btrfs.
>>
>> Thoughts?
>
> Perhaps, but given it's not yet clear whether another file system will
> require similar support from GRUB, I'd rather keep things as explicit as
> possible for now.

To me, another consideration is familiarity with Btrfs for those who’ll
touch the code: to someone not familiar with it, the code may be viewed
as “read-only” because it says “btrfs”.  Whereas if it clearly states
that it’s just about prepending a directory name or similar, it’s easy
to reason about it.

>> Anyway, that’s great work, so I’ll be happy to finally see it committed
>> in the coming days!
>
> Thanks for the great words and for having a last look :-).
>
> I've added a news entry and pushed to master as:
>
> 489699c456 allow-booting-from-btrfs-subvolume news: Add entry for Btrfs subvolume boot support.
> b460ba7992 bootloader: grub: Allow booting from a Btrfs subvolume.
> fa35fb58c8 file-systems: Add helpers for parsing the options string into an alist.
> 281d80d8e5 linux-boot: Refactor boot-system.
>
> Closing!  Thanks to Pierre and Ludovic for testing and reviewing.

That’s great news, thanks a lot for your work… and for your patience!

Ludo’.